/* 
 * File:   main.c
 * Author: Miguel Lorenzo Amarelle
 *
 * Created on 29 de octubre de 2009, 12:34
 */
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>
#include <stdbool.h>    // boolean datatype
#include "customList.h" //CustomList functions

const double timeslice =500;//50,100,250,500
const double contextchangue =0;//0,5,10,15,20,25



//Function Declarations
void init();
int getRandomInt();

//Global Variables
struct customList *myList;//the element of the list where we will placed

/*
 *init -- initialites the list
 */
void init()
    {
    //mylist= (struct customList *) malloc(sizeof(struct customList));
    //INIT_LIST_HEAD(&mylist->list);
    //mylist->pid=getRandomInt();
    //first_element=&mylist->list;
    }



/*
 *getRandomInt -- returns a random int value
 */
int getRandomInt(int maxValue)
    {
    int toret;//int value toreturn
    //srand(time(NULL));//initialize the random seed with the system time
    toret= (int)random()/(maxValue+1);//we get a random number and make a casting from double to int
    return toret;
    }


/*
 *startSchediling -- starts the round robin simulation
 * actualemenet -- the tail where are the process to use in the simulation
 *
 */
void startScheduling(struct customList *processList, int timeslice, int contextchangue)
    {
    int actualTime=0;//For use in arrival time
    int elements;
    elements=getElementsCount(processList);
    //printf("We have %d process\n",elements);
    while(elements>=0)//There are active process in the list
        {
        //pass time
        //printf("Checking\n");
        actualTime+=contextchangue;
        if (processList->finished==false && processList->arrivetime<=actualTime)//process can be accepted by the round robin policy
            {
            //Check waiting time
            if (processList->waitaverange==0)//First CPU obtention
                {
                processList->waitaverange=actualTime-processList->arrivetime;
                }
            else//Gets CPU time
                {
                processList->waitaverange=(processList->waitaverange+(actualTime-processList->lastScheculerActiveTime))/2;
                }
            processList->stopCounter++;
            processList->processtime=(processList->processtime)-timeslice;

            //printf("processtime == %d\n",processList->processtime);
            if (processList->processtime<=0)//The process has ended
                {
                actualTime-=processList->processtime;
                //processList->processtime=0;
                processList->finished=true;
                elements--;
                //printf("Process %d ended\n",processList->pid);
                printLine(processList,timeslice,contextchangue);
                }
            else//The process need more cpu time
                {
                actualTime+=timeslice;
                processList->lastScheculerActiveTime =actualTime;
                }
            }
            //Move next element
            processList=getCustomListPointer((processList->list).next);
        }
    //printf("End of Round Robin\n");

    }


int main(int argc, char** argv) {
    if (argc>0)
        {
        //printf("No arguments used you passed %d\n",argc);
        }
    //init();
    myList=NULL;
    int x;
    for (x=0;x<15000;x++)
        {
        //printf("Adding element %d\n",x);
        addNewElement(x,0,getRandomInt(12000),0,false,&myList);
        //printf("MyList points to %p\n",myList);
        //printSelectListElement(myList,"");
        }
   // printf("removing");
    //deleteByPid(5,&myList->list);
    //printf("Elements to be processed=%d\n",getElementstoProcessCount());
    //Show al the list using the iterator
    struct list_head *iteratorElement;
    iteratorElement=&myList->list;

    int timeslice=50;
    int contextchangue=0;
    struct list_head *listIterator;
    struct customList *copiedList;
    //printCVSHeader();<- not used for mysql importation
        while(timeslice<501)
            {
            contextchangue=0;
            while (contextchangue<26)
                {
                //printf("timeslice=%d\t contextchangue=%d\n",timeslice,contextchangue);
                listIterator=&myList->list;
                copiedList=NULL;
                //printf("Copying list\n");
                copyCustomList(&myList->list,&copiedList,&myList->list);
                //printf("List Copied\n");
                iteratorElement=&copiedList->list;
                initializeIterador(iteratorElement);
                do{
                   //printSelectListElement(getCustomListPointer(iteratorElement),"Copied");
                   //move to the next element
                   iteratorElement=iteratorElement->next;
                   }while(hasNext(iteratorElement)); 
                //printf("Scheculing\n");
                startScheduling(copiedList,timeslice,contextchangue);
                //printf("Scheculed\n");
                EmptyCustomList(&(copiedList->list),NULL);
                contextchangue+=5;
                }
            timeslice*=2;
            if (timeslice==200)
                {
                timeslice+=50;
                }
            }
    return (EXIT_SUCCESS);
}